//
//  ByteUtil.java
//  Trikebot
//
//  Created by Andrs Santiago Prez-Bergquist on Tue Jun 11 2002.
//  Copyright (c) 2002. All rights reserved.
//

public class ByteUtil extends java.lang.Object
{
	// Converts a signed byte to an unsigned value as an integer
	public static int Unsign(byte b)
	{
        return (b + 256) % 256;
    }

	// Returns a byte with the high 8 bits of a 16 bit integer
	public static byte Hi(int I)
	{
		return ((byte) (I >> 8));
	}

	// Returns a byte with the LOW 8 bits of a 16 bit integer
	public static byte Lo(int I)
	{
		return ((byte) (I & 255));
	}

	// Reassembles two bytes into an unsigned 16-bit integer (returned as an int)
	public static int AssembleUnsigned(byte hi, byte lo)
	{
		return (Unsign(hi) << 8) | Unsign(lo);
		//return Unsign(hi) * 256 + Unsign(lo);
	}

	// Reassembles two bytes into a signed 16-bit integer (returned as an int)
	public static int AssembleSigned(byte hi, byte lo)
	{
		int u =  AssembleUnsigned(hi, lo);

		if (u < 32768)
			return u;
		else
			return (u - 65536);
	}

	// Splits a long into an array of eight bytes
	public static byte[] SplitLong(long l)
	{
		byte[] b = new byte[8];
		long L = l;
		for (int i = 7; i >= 0; i--)
		{
			b[i] = (byte) L;
			L = L >> 8;
		}
		return b;
	}

	// Builds a long from an array of eight bytes
	public static long BuildLong(byte[] b)
	{
		long L = 0;
		for (int i = 0; i < 8; i++)
			L = (L << 8) | Unsign(b[i]);
		/*
		{
			L *= 256;
			L += Unsign(b[i]);
		}
		*/
		return L;
	}
}
