//
//  Checksum.java
//  Trikebot
//
//  Created by Andrs Santiago Prez-Bergquist on Thu Jun 13 2002.
//  Copyright (c) 2002. All rights reserved.
//

public class Checksum extends java.lang.Object
{
	// Returns the checksum for the packet
	public static byte Compute(byte[] packet)
	{
        int l = packet.length;
		byte csum = 0;
		for (int i = 0; i <= l-2; i++)
			csum += packet[i];
		csum %= 256;
		return csum;
	}

	// Sets the value of the last byte to be equal to the checksum of the rest of the packet
	public static void Set(byte[] packet)
	{
		packet[packet.length - 1] = Compute(packet);
	}

	// Returns true iff the last byte is equal to the checksum of the rest of the packet
	public static boolean IsValid(byte[] packet)
	{
		return (packet[packet.length - 1] == Compute(packet));
	}
}
