/*
 * JoystickWindow.java
 *
 * Created on June 12, 2002, 7:05 PM
 */

import java.awt.*;

public class JoystickWindow extends javax.swing.JFrame implements Runnable {

    TrikebotController	trikebot;
	boolean				mouseStillDown = false;
	Thread				Tickle;
    
    /** Creates new form JoystickWindow */
    public JoystickWindow(TrikebotController t)
	{
        trikebot = t;
        initComponents();
		drive.setBounds(0, (int) drive.getLocation().getY(), 200, 200);
		look.setBounds(200, (int) look.getLocation().getY(), 200, 200);
		Tickle = new Thread(this);
		Tickle.start();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        drive = new JoystickCanvas(200, 200, -90, 90, -100, 100);
        look  = new JoystickCanvas(200, 200, -90, 90, -45, 90);
        ResetDrive = new javax.swing.JButton();
        ResetLook = new javax.swing.JButton();
        DriveLabel = new javax.swing.JLabel();
        LookLabel = new javax.swing.JLabel();
        TurnLabel = new javax.swing.JLabel();
        Turn = new javax.swing.JTextField();
        SpeedLabel = new javax.swing.JLabel();
        Speed = new javax.swing.JTextField();
        PanLabel = new javax.swing.JLabel();
        Pan = new javax.swing.JTextField();
        TiltLabel = new javax.swing.JLabel();
        Tilt = new javax.swing.JTextField();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setTitle("Joysticks");
        setResizable(false);
		/*
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent event) {
                exitForm(event);
            }
        });
		 */
        
        drive.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent event) {
                driveMousePressed(event);
            }
            public void mouseReleased(java.awt.event.MouseEvent event) {
                driveMouseReleased(event);
            }
        });
        
        drive.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent event) {
                driveMouseDragged(event);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        getContentPane().add(drive, gridBagConstraints1);

        look.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent event) {
                lookMousePressed(event);
            }
            public void mouseReleased(java.awt.event.MouseEvent event) {
                lookMouseReleased(event);
            }
        });
        
        look.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent event) {
                lookMouseDragged(event);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        getContentPane().add(look, gridBagConstraints1);
        
        ResetDrive.setText("Recenter");
        ResetDrive.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent event) {
                ResetDriveActionPerformed(event);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(ResetDrive, gridBagConstraints1);
        
        ResetLook.setText("Recenter");
        ResetLook.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent event) {
                ResetLookActionPerformed(event);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(ResetLook, gridBagConstraints1);
        
        DriveLabel.setText("Drive");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 4;
        getContentPane().add(DriveLabel, gridBagConstraints1);
        
        LookLabel.setText("Look");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 4;
        getContentPane().add(LookLabel, gridBagConstraints1);
        
        TurnLabel.setText("Turn");
        TurnLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(TurnLabel, gridBagConstraints1);
        
        Turn.setText("0");
        Turn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TurnActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(Turn, gridBagConstraints1);
        
        SpeedLabel.setText("Speed");
        SpeedLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(SpeedLabel, gridBagConstraints1);
        
        Speed.setText("0");
        Speed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SpeedActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(Speed, gridBagConstraints1);
        
        PanLabel.setText("Pan");
        PanLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(PanLabel, gridBagConstraints1);
        
        Pan.setText("0");
        Pan.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PanActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 5;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(Pan, gridBagConstraints1);
        
        TiltLabel.setText("TIlt");
        TiltLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 6;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(TiltLabel, gridBagConstraints1);
        
        Tilt.setText("0");
        Tilt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TiltActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 7;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.25;
        getContentPane().add(Tilt, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void lookMousePressed(java.awt.event.MouseEvent event) {//GEN-FIRST:event_lookMousePressed
		MouseLook(event);
    }//GEN-LAST:event_lookMousePressed

    private void lookMouseReleased(java.awt.event.MouseEvent event) {//GEN-FIRST:event_lookMouseReleased
        MouseLook(event);
    }//GEN-LAST:event_lookMouseReleased

    private void lookMouseDragged(java.awt.event.MouseEvent event) {//GEN-FIRST:event_lookMouseDragged
		MouseLook(event);
    }//GEN-LAST:event_lookMouseDragged

	private synchronized void driveMousePressed(java.awt.event.MouseEvent event) {//GEN-FIRST:event_driveMousePressed
		MouseDrive(event);
		mouseStillDown = true;
		notify();
    }//GEN-LAST:event_driveMousePressed

    private synchronized void driveMouseReleased(java.awt.event.MouseEvent event) {//GEN-FIRST:event_driveMouseReleased
        mouseStillDown = false;
		MouseDrive(event);
		trikebot.KillMotor();
    }//GEN-LAST:event_driveMouseReleased

	private synchronized void driveMouseDragged(java.awt.event.MouseEvent event) {//GEN-FIRST:event_driveMouseDragged
		MouseDrive(event);
	}//GEN-LAST:event_driveMouseDragged
	
	private void TiltActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TiltActionPerformed
		int tilt = Integer.parseInt(Tilt.getText());
        ShowTilt(tilt);
		trikebot.TiltHeadTo(tilt);
		trikebot.root.ShowState();
    }//GEN-LAST:event_TiltActionPerformed

    private void PanActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PanActionPerformed
        int pan = Integer.parseInt(Pan.getText());
		ShowPan(pan);
		trikebot.PanHeadTo(pan);
		trikebot.root.ShowState();
    }//GEN-LAST:event_PanActionPerformed

    private void SpeedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SpeedActionPerformed
        int vel   = Integer.parseInt(Speed.getText());
		int angle = Integer.parseInt(Turn.getText());
		ShowVel(vel);
		trikebot.Drive(vel, angle);
		trikebot.root.ShowState();
    }//GEN-LAST:event_SpeedActionPerformed

    private void TurnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TurnActionPerformed
        int angle = Integer.parseInt(Turn.getText());
		ShowTurn(angle);
		trikebot.TurnWheelTo(angle);
		trikebot.root.ShowState();
    }//GEN-LAST:event_TurnActionPerformed
	
	private void ResetLookActionPerformed(java.awt.event.ActionEvent event) {
		look.Recenter();
		Pan.setText("0");
		Tilt.setText("0");
		trikebot.MoveHeadTo(0, 0);
		trikebot.root.ShowState();
	}
	
	private void ResetDriveActionPerformed(java.awt.event.ActionEvent event) {
		drive.Recenter();
		Turn.setText("0");
		Speed.setText("0");
		trikebot.TurnWheelTo(0);
		trikebot.KillMotor();
		trikebot.root.ShowState();
	}

	private void MouseLook(java.awt.event.MouseEvent event)
	{
		look.SetPos(event.getX(), event.getY());
		int pan  = (int) look.X();
		int tilt = (int) look.Y();
		Pan.setText(String.valueOf(pan));
		Tilt.setText(String.valueOf(tilt));
		trikebot.MoveHeadTo(pan, tilt);
		trikebot.root.ShowState();
	}

	private void MouseDrive(java.awt.event.MouseEvent event)
	{
		drive.SetPos(event.getX(), event.getY());
		int turn = (int) drive.X();
		int vel  = (int) drive.Y();
		Turn.setText(String.valueOf(turn));
		Speed.setText(String.valueOf(vel));
		trikebot.Drive(vel, turn);
		trikebot.root.ShowState();
	}
	
	public void ShowPan(int pan)
	{
		look.SetLogicalX(pan);
		Pan.setText(String.valueOf(pan));
	}
	
	public void ShowTilt(int tilt)
	{
		look.SetLogicalY(tilt);
		Tilt.setText(String.valueOf(tilt));
	}
	
	public void ShowTurn(int turn)
	{
		drive.SetLogicalX(turn);
		Turn.setText(String.valueOf(turn));
	}
	
	public void ShowVel(int vel)
	{
		drive.SetLogicalY(vel);
		Speed.setText(String.valueOf(vel));
	}
	
	public void run() // Thread to tickle the robot and keep driving if you hold the mouse still
	{
		try
		{
			while(true)
			{
				boolean pause;
				synchronized (this)
				{
					if (mouseStillDown) // Checking of state and doing resulting action needs to be atomic
					{
						int turn = (int) drive.X();
						int vel  = (int) drive.Y();
						trikebot.Drive(vel, turn);
						trikebot.root.ShowState();
						pause = true; // Don't want to do the sleeping here, release the lock ASAP
					}
					else
					{
						wait();
						pause = false; // No need to sleep, we just got woken up
					}
				}
				if (pause)
					Time.Sleep(2000);
			}
		}
		catch(InterruptedException e)
		{
			return;
		}
	}
	
    private void exitForm(java.awt.event.WindowEvent event) {//GEN-FIRST:event_exitForm
        
    }//GEN-LAST:event_exitForm

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JoystickCanvas drive;
    private JoystickCanvas look;
    private javax.swing.JButton ResetDrive;
    private javax.swing.JButton ResetLook;
    private javax.swing.JLabel DriveLabel;
    private javax.swing.JLabel LookLabel;
    private javax.swing.JLabel TurnLabel;
    private javax.swing.JTextField Turn;
    private javax.swing.JLabel SpeedLabel;
    private javax.swing.JTextField Speed;
    private javax.swing.JLabel PanLabel;
    private javax.swing.JTextField Pan;
    private javax.swing.JLabel TiltLabel;
    private javax.swing.JTextField Tilt;
    // End of variables declaration//GEN-END:variables
}
