/*
 * MacroWindow.java
 *
 * Created on July 22, 2002, 8:51 AM
 */

import javax.swing.*;

public class MacroWindow extends javax.swing.JFrame
{
    TrikebotController	trikebot;
	boolean				recording;
    
    /** Creates new form MacroWindow */
    public MacroWindow(TrikebotController t)
	{
		trikebot = t;
        initComponents();
        MacroList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ShowMacros();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        Open = new javax.swing.JButton();
        SaveAs = new javax.swing.JButton();
        Record = new javax.swing.JButton();
        Play = new javax.swing.JButton();
        MacroListScrollPane = new javax.swing.JScrollPane();
        MacroList = new javax.swing.JList();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setTitle("Macros");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        Open.setText("Open...");
        Open.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OpenActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.5;
        getContentPane().add(Open, gridBagConstraints1);
        
        SaveAs.setText("Save As...");
        SaveAs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveAsActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.5;
        getContentPane().add(SaveAs, gridBagConstraints1);
        
        Record.setText("Record");
        Record.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RecordActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.5;
        getContentPane().add(Record, gridBagConstraints1);
        
        Play.setText("Play");
        Play.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PlayActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 0.5;
        getContentPane().add(Play, gridBagConstraints1);
        
        MacroListScrollPane.setViewportView(MacroList);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        getContentPane().add(MacroListScrollPane, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void RecordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RecordActionPerformed
        if (recording)
        {
            recording = false;
            Record.setText("Record");
            String name = JOptionPane.showInputDialog(this,
													  "Please enter a name for the macro:",
													  "Macro Name Request",
													  JOptionPane.QUESTION_MESSAGE);
			if (name == null)
				trikebot.macros.CancelRecording();
			else
				trikebot.macros.StopRecording(name);
			ShowMacros();
        }
        else
        {
            recording = true;
            Record.setText("Stop");
            trikebot.macros.StartRecording();
        }
    }//GEN-LAST:event_RecordActionPerformed

    private void PlayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PlayActionPerformed
        String name = (String) MacroList.getSelectedValue();
        if (name != null)
            trikebot.macros.PlayBack(name);
    }//GEN-LAST:event_PlayActionPerformed

    private void OpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OpenActionPerformed
        JFileChooser fc = new JFileChooser();
		int returnVal = fc.showOpenDialog(this);

		if (returnVal == JFileChooser.APPROVE_OPTION)
		{
            String name = JOptionPane.showInputDialog(this,
													  "Please enter a name for the macro:",
													  "Macro Name Request",
													  JOptionPane.QUESTION_MESSAGE);
			if (name != null)
				trikebot.macros.Open(name, fc.getSelectedFile());
			ShowMacros();
		}
    }//GEN-LAST:event_OpenActionPerformed

    private void SaveAsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveAsActionPerformed
		String name = (String) MacroList.getSelectedValue();
        if (name != null)
		{
			JFileChooser fc = new JFileChooser();
			int returnVal = fc.showSaveDialog(this);

			if (returnVal == JFileChooser.APPROVE_OPTION)
			{
				trikebot.macros.Save(name, fc.getSelectedFile());
			}
		}
    }//GEN-LAST:event_SaveAsActionPerformed

    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        
    }//GEN-LAST:event_exitForm

	public void ShowMacros()
	{
		MacroList.setListData(trikebot.macros.Defined());
	}

        // Variables declaration - do not modify//GEN-BEGIN:variables
        private javax.swing.JButton Open;
        private javax.swing.JButton SaveAs;
        private javax.swing.JButton Record;
        private javax.swing.JButton Play;
        private javax.swing.JScrollPane MacroListScrollPane;
        private javax.swing.JList MacroList;
        // End of variables declaration//GEN-END:variables

}
