//
//  RangeCanvas.java
//  Trikebot
//
//  Created by Andrs Santiago Prez-Bergquist on Mon Jun 17 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

import java.awt.*;

public class RangeCanvas extends Canvas
{
	int reading;
	int heading;
	int[] readings;
	int	start, end, step;
	int sizeX, sizeY;				// Width and height in pixels
	
	public RangeCanvas(int width, int height)
	{
		setSize(width, height);
		reading = 255;
		readings = null;
	}

	// Resize to so many pixels
	public void setSize(int width, int height)
	{
		sizeX = width;
		sizeY = height;
		//super.setSize(sizeX, sizeY);
	}

	public void setSize(Dimension d)
	{
		sizeX = d.width;
		sizeY = d.height;
		//super.setSize(sizeX, sizeY);
	}

	public Dimension getMinimumSize()
	{
		return new Dimension(sizeX, sizeY);
	}

	public Dimension getPreferredSize()
	{
		return new Dimension(sizeX, sizeY);
	}

	public Dimension getMaximumSize()
	{
		return new Dimension(sizeX, sizeY);
	}
	
	public void ShowReading(int distance, int degrees)
	{
		reading = distance;
		heading = degrees;
		
		readings = null;
		repaint();
	}
	
	public void ShowSweep(int[] rdngs, int strt, int nd, int stp)
	{
		readings = rdngs;
		start	 = strt;
		end 	 = nd;
		step 	 = stp;
		repaint();
	}
	
	public void DrawReading(Graphics g, int dis, int ang)
	{
		double radians = Math.PI / 180.0 * ang;
		double scale = (255 - dis) / 255.0;
		g.drawLine(sizeX/2, sizeY, (int) ((1 + Math.sin(radians)*scale) * sizeX/2),
								   (int) (sizeY * (1 - Math.cos(radians)*scale)));
	}
	
	public void paint (Graphics g)
	{
		g.setColor(Color.white);
		g.fillRect(0, 0, sizeX, sizeY);

		g.setColor(Color.lightGray);
		g.fillOval(0, 0, sizeX, sizeY*2);
		
		g.setColor(Color.blue);
		if (readings == null)
			DrawReading(g, reading, heading);
		else
			for (int th = start, i = 0; th <= end; th += step, i++)
				DrawReading(g, readings[i], th);
	}
}