//
//  Shell.java
//  Trikebot
//
//  Created by Andrs Santiago Prez-Bergquist on Fri Jun 07 2002.
//  Copyright (c) 2002. All rights reserved.
//

import java.awt.*;
import java.applet.*;
import javax.swing.*;


public class Shell extends java.lang.Object
{
	TrikebotController trikebot;

	public CalibrationWindow	theCalibrationWindow;
	public CameraWindow			theCameraWindow;
	public ConnectionWindow		theConnectionWindow;
	public FramegrabWindow		theFramegrabWindow;
	public JoystickWindow		theJoystickWindow;
	public MacroWindow			theMacroWindow;
	public MotorWindow			theMotorWindow;
	public PIDWindow			thePIDWindow;
	public RangeWindow			theRangeWindow;
	public TrackWindow			theTrackWindow;
	public UserWindow			theUserWindow;

	public Shell()
	{
		AboutWindow theAboutWindow = new AboutWindow();
		theAboutWindow.setVisible(true);
		
		trikebot = new TrikebotController(this);

		theConnectionWindow	= new ConnectionWindow(trikebot);
		theConnectionWindow.setLocation(0, 0);

		theCameraWindow		= new CameraWindow(trikebot);
		theCameraWindow.setLocation(0, 118);

		theMotorWindow		= new MotorWindow(trikebot);
		theMotorWindow.setLocation(415, 0);
		
		theUserWindow		= new UserWindow(trikebot);
		theUserWindow.setLocation(0, 500);

		theCalibrationWindow= new CalibrationWindow(trikebot);
		theCalibrationWindow.setLocation(400, 500);
		
		thePIDWindow		= new PIDWindow(trikebot);
		thePIDWindow.setLocation(515, 380);

		theJoystickWindow	= new JoystickWindow(trikebot);
		theJoystickWindow.setLocation(670, 0);

		theFramegrabWindow	= new FramegrabWindow(trikebot);
		theFramegrabWindow.setLocation(645, 500);

		theTrackWindow		= new TrackWindow(trikebot);
		theTrackWindow.setLocation(0, 380);

		theRangeWindow		= new RangeWindow(trikebot);
		theRangeWindow.setLocation(645, 308);

		theMacroWindow		= new MacroWindow(trikebot);
		theMacroWindow.setLocation(500, 250);
		
		theConnectionWindow.SetStatus("Ready (v"+Version.text+")");
		
		theAboutWindow.setVisible(false);

		// Want to order them from back to front
		theCalibrationWindow.setVisible(true);
		theMacroWindow.setVisible(true);
		theCameraWindow.setVisible(true);
		theMotorWindow.setVisible(true);
		theUserWindow.setVisible(true);
		thePIDWindow.setVisible(true);
		theJoystickWindow.setVisible(true);
		theFramegrabWindow.setVisible(true);
		theTrackWindow.setVisible(true);
		theRangeWindow.setVisible(true);
		theConnectionWindow.setVisible(true);
	}
	
	public void ShowStatus()
    {
        theConnectionWindow.ShowStatus();
    }
	
	public void ShowState()
    {
        theConnectionWindow.ShowStatus();
        theRangeWindow.ShowRange();
        theMotorWindow.ShowVoltAmp();
    }

	public static void main(String args[])
	{
        new Shell();
	}
}
