/*
 * TrackThread.java
 *
 * Created on May 13, 2002, 10:57 AM
 */



/*
5002 does not accept input.  It returns data from active tracking, when enabled via port 5000.  Packets are of the form:

<pan>
<tilt>
<trackX>
<trackY>
<trackWidth>
<trackHeight>
<trackPixels>
<trackConf>
<csum>
*/

public class TrackThread extends java.lang.Thread
{
    private TrikebotController trikebot;
    private NetPort trackingPort;
    boolean quit;

    /** Creates new TrackThread */
    public TrackThread(TrikebotController parent, NetPort trackNet)
	{
        trikebot = parent;
        trackingPort = trackNet;
        quit = false;
    }

    public void destroy()
	{
        quit = true;
    }

    public void run()
	{
        byte[] packet;
        quit = false;
        
        while (!quit)
		{
			packet = trackingPort.ReadByteLine();
			if (packet.length != 9 || !Checksum.IsValid(packet))
				break;
			
			trikebot.state.SetPan(  trikebot.PanPos2Angle(ByteUtil.Unsign(packet[0]))  );
            trikebot.state.SetTilt( trikebot.TiltPos2Angle(ByteUtil.Unsign(packet[1])) );
            trikebot.track.x 		= ByteUtil.Unsign(packet[2]);
            trikebot.track.y 		= ByteUtil.Unsign(packet[3]);
            trikebot.track.width 	= ByteUtil.Unsign(packet[4]);
			trikebot.track.height	= ByteUtil.Unsign(packet[5]);
			trikebot.track.pixels	= ByteUtil.Unsign(packet[6]);
			trikebot.track.conf		= ByteUtil.Unsign(packet[7]);

			// Need to update joystick and tracking info window
			trikebot.root.theJoystickWindow.ShowPan(trikebot.state.Pan());
			trikebot.root.theJoystickWindow.ShowTilt(trikebot.state.Tilt());
			trikebot.root.theTrackWindow.ShowTrack();

			/*
			System.err.println("Pan: "+trikebot.state.Pan()+" Tilt:  "+trikebot.state.Tilt()
							  +" X: "+trikebot.track.x+" Y: "+trikebot.track.y
							  +" Width: "+trikebot.track.width+" Height: "+trikebot.track.height
							  +" Pixels: "+trikebot.track.pixels + " Conf: " + trikebot.track.conf);
			*/
		}
    }
}
